SystemOrganization addCategory: #'IRDA2013-Searching'!
SystemOrganization addCategory: #'IRDA2013-Searching-Tests'!

CircleMorph subclass: #I2SVisualNode
	instanceVariableNames: 'node parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:25:40.439'!
blankNodeWidth
	^40! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 12:19:35.238'!
levelHeight
	^20! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 11:45:53.114'!
newWithNode: aNode
	| a |
	a := self new.
	a node: aNode.
	a draw.
	a drawChildren. 
	"a bounds: a fullBounds."

	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:33:17.713'!
newWithNode: aNode parent: aMorph
	| a |
	a := self new.
	a parent: aMorph.
	a parent addMorph: a.
"	a openInWorld."
	a position: 300@60.
	a node: aNode.
	a draw.
	a drawChildren. 

	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 12:16:17.828'!
nodeSpace
	^20! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:36:22.217'!
draw
	self color: (self node getValueAt: 1).! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:26:01.169'!
drawChildren 
	| node totalWidth children offset |
	node := self node.
	totalWidth := 0.
	children := OrderedCollection new.
	(node children "select: [:ea | ea notNil ]") 
		do: [ :child || a |
			"iterate over all children, draw them recursively. Ask the child what it's bounds are and calculate the total width of all subtrees of the current node. In a second iteration over all children, position them."
			child isNil 
			ifTrue: [
				children add: nil.
				totalWidth := totalWidth + self class blankNodeWidth.
			] 
			ifFalse: [
				a := self class newWithNode: child.
				children add: a.
				totalWidth := totalWidth + (a fullBounds width).
			].
		].
	"between childs there should be some space, so we add this to the total width"
	totalWidth := totalWidth + (((children size) - 1) * self class nodeSpace).
	offset := 0 - (totalWidth / 2).
	children do: [:child ||x y|
		child isNil ifTrue: [
			offset := offset + self class blankNodeWidth + self class nodeSpace.
		] 
		ifFalse: [
			x := (offset + (child fullBounds width / 2)).
			y := self class levelHeight + self bounds height.
			child position: x@y.
			offset := offset + child fullBounds width + self class nodeSpace.
			self addMorph: child.
			"the line"
			self addMorph: (LineMorph 
					from: self bounds bottomCenter 
					to: child bounds topCenter
					color: Color black 
					width: 5). 
		]
	].
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:50.635'!
node
 ^node! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:54.969'!
node: aNode
 node := aNode! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:37.503'!
parent
	^parent! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:27.117'!
parent: aMorph
	parent := aMorph.! !

Morph subclass: #I2SVisualization
	instanceVariableNames: 'rootNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualization class methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:35:08.134'!
newWithNode: aNode

  	|a visNode |
  	a := self new.
	a setRootNode: aNode.
	
	^a
  ! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:22:10.297'!
addedChild: aNode to: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:39:38.025'!
initialize 
	super initialize.
	self color: Color transparent.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:33:12.866'!
removedChild: aNode from: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:10:46.932'!
rootNode
	^rootNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:11:04.226'!
rootNode: aNode
	rootNode := aNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 14:38:02.982'!
setRootNode: aRoot

	| visNode |
	self rootNode: aRoot.

  	visNode := (I2SVisualNode newWithNode:  aRoot).
  	self addMorph: visNode.
	visNode position: ((visNode fullBounds width / 2) - (visNode bounds width / 2) )@0.
  	self bounds: visNode fullBounds.

  	self position: ActiveWorld visibleClearArea origin.

 	self setupConnections.
  	^self! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:32:57.414'!
setupConnections

	self connect: self rootNode signal: #addedChild:to:at: toSelector: #addedChild:to:at:.
	
	self connect: self rootNode signal: #removedChild:from:at: toSelector: #removedChild:from:at:.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 14:05:45.151'!
updateTree
	| visNode |
	self removeAllMorphs.
	visNode := (I2SVisualNode newWithNode:  self rootNode).
  self addMorph: visNode.
  self bounds: visNode fullBounds.
  visNode position: 0@0.
  self position: ActiveWorld visibleClearArea origin.! !

Object subclass: #I2STestNode
	instanceVariableNames: 'value children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:37:45.65'!
children
	^children! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:00.496'!
children: anOrderedCollection
	children := anOrderedCollection! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:05.751'!
initialize

	self children: OrderedCollection new! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:05.903'!
value 
 ^value! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:11.427'!
value: aValue
 value := aValue! !

Object subclass: #I2STreeNode
	instanceVariableNames: 'parent children numChildren values maxChildren maxValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STreeNode subclass: #I2SBinaryTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SBinaryTreeNode subclass: #I2SBinarySearchTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:13:37.331'!
addValue: aValue

	(self value > aValue) ifTrue:[
		self leftChild ifNil: [
				self leftChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self leftChild addValue: aValue.
			].
		]ifFalse:[
			self rightChild ifNil: [
				self rightChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self rightChild addValue: aValue.
			].
		]! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:14:57.827'!
find: aValue

	(self value = aValue) ifTrue: [
		^true
	] ifFalse: [
		(self value > aValue) ifTrue:[
			self leftChild ifNil: [
				^false
			] ifNotNil: [
				^self leftChild find: aValue.
			]
		] ifFalse:[
			self rightChild ifNil: [
				^false
			] ifNotNil: [
				^self rightChild find: aValue.
			]
		]
	]! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:06:37.881'!
initialize

	super initialize.! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:18:08.152'!
remove: aValue

	! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:29:46.754'!
initialize

	super initialize.
	self maxChildren: 2.
	self maxValues: 1.
	self leftChild: nil.
	self rightChild: nil.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:24:29.906'!
leftChild

	^self getChildAt: 1.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:17.767'!
leftChild: aNode

	self leftChild ifNotNil: [
		self removeChildAt: 1.].
	
	aNode ifNotNil:[
		self addChild: aNode at: 1.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:24:43.915'!
rightChild

	^self getChildAt: 2.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:25.394'!
rightChild: aNode
	
	self rightChild ifNotNil:[
		self removeChildAt: 2.].
	aNode ifNotNil:[
		self addChild: aNode at: 2.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:40:48.388'!
value
	^self getValueAt: 1.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:38:34.794'!
value: aValue
	self setValue: aValue at: 1.! !

!I2STreeNode class methodsFor: 'constructors' stamp: 'benjamin.siegmund 5/2/2013 17:27:22.311'!
newWithValue: aValue
	| out |
	out := self new.
	out setValue: aValue at: 1.
	^out. ! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/15/2013 11:22:09.258'!
addChild: newRoot at: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	newRoot parent ifNotNil: [
		self error: 'node already has a parent'].

	[children size < position] whileTrue: [
		children add: nil].

	(children at: position) ifNil: [
		children at: position put: newRoot.
		newRoot parent: self.
		 self
			connect: newRoot
			signal: #addedChild:to:at:
			toSelector: #fireAddedChild:to:at:.
		self
			connect: newRoot
			signal: #removedChild:from:at:
			toSelector: #fireRemovedChild:from:at:.
		self addedChild: newRoot to: self at: position.
		numChildren := numChildren+1.] ifNotNil: [
		self error: 'child already present.'
		].! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 5/2/2013 15:42:15.911'!
addedChild: newRoot to: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:07.532'!
children

^children! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:18:41.375'!
fireAddedChild: newRoot to: parent at: position

self addedChild: newRoot to: parent at: position.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 11:19:01.382'!
fireRemovedChild: root from: parent at: position

self removedChild: root from: parent at: position.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 12:38:13.762'!
getChildAt: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	children size >= position ifTrue: [
		^children at: position] ifFalse: [
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 12:39:31.575'!
getValueAt: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'.].

	(values size >= position) ifTrue: [
		^values at: position.] ifFalse:[
		^nil.].! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:24.062'!
hasChildren

^numChildren > 0! !

!I2STreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 5/8/2013 14:02:08.986'!
initialize

	parent := nil.
	children := OrderedCollection new.
	values := OrderedCollection new.
	numChildren := 0.
	maxChildren := 10.
	maxValues := 9.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:55:44.372'!
maxChildren

	^maxChildren.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:56:18.137'!
maxChildren: aNumber

	maxChildren := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:54:45.456'!
maxValues

	^maxValues.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:55:05.223'!
maxValues: aNumber

	maxValues := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:30.94'!
numChildren

^numChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 14:02:43.517'!
parent

	^parent.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 14:02:41.641'!
parent: aNode

	parent := aNode.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/15/2013 11:22:26.382'!
removeChildAt: position
(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].
	
children size >= position ifTrue: [
	(children at: position) ifNotNil:[
		| child |
		child := children at: position.
		children at: position put: nil.
		child parent: nil.
		child
			disconnectSignal: #addedChild:to:at:
			from: self
			selector: #fireAddedChild:to:at:.
		child
			disconnectSignal: #removedChild:from:at:
			from: self
			selector: #fireRemovedChild:from:at:.
		self removedChild: child from: self at: position.
		numChildren := numChildren-1.]]! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 5/8/2013 12:32:19.327'!
removedChild: root from: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:53:59.231'!
setValue: aValue at: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'.].

	[values size < position] whileTrue: [
		values add: nil].

	values at: position put: aValue.! !

TestCase subclass: #I2STreeNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:18:11.279'!
setUp
	super setUp.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:26:52.118'!
tearDown
	super tearDown.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 12:45:48.174'!
test01Initialisation
	| a |
	a := I2STreeNode newWithValue: #a.
	self assert: #a equals: (a getValueAt: 1).
	self assert: (a hasChildren) not.
	self assert: 0 equals: (a numChildren).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:54:01.813'!
test02Limits
	| a |
	a := I2STreeNode new.
	a maxChildren: 2.
	a maxValues: 1.
	
self should: [a getValueAt: 0] raise: Error.
self shouldnt: [a getValueAt: 1] raise: Error.
self should: [a getValueAt: 2] raise: Error.
self should: [a setValue: 0 at: 0] raise: Error.
self shouldnt: [a setValue: 0 at: 1] raise: Error.
self should: [a setValue: 0 at: 2] raise: Error.
self should: [a getChildAt: 0] raise: Error.
self shouldnt: [a getChildAt: 1] raise: Error.
self shouldnt: [a getChildAt: 2] raise: Error.
self should: [a getChildAt: 3] raise: Error.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:13:41.649'!
test03Children
	| a b c |
	a := I2STreeNode new.
	b := I2STreeNode new.
	c := I2STreeNode new.
	
	a addChild: b at: 1.
	self assert: b equals: (a getChildAt: 1).
	self should: [a addChild: b at: 2] raise: Error.
	self should: [a addChild: c at: 1] raise: Error.
	a addChild: c at: 2.
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (b parent).
	self assert: a equals: (c parent).
	
	a removeChildAt: 1.
	self assert: ((a getChildAt: 1) isNil).
	self assert: (b parent isNil).
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (c parent).
	a removeChildAt: 2.
	self assert: (a getChildAt: 2) isNil.
	self assert: c parent isNil.
	
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:57:07.369'!
test04ChildrenAndLimits
	| a b |
	a := I2STreeNode new.
	b := I2STreeNode new.
	a maxChildren: 1.
	
	self should: [ a addChild: b at: 0] raise: Error.
	self should: [ a addChild: b at: 2] raise: Error.
	self shouldnt: [ a addChild: b at: 1] raise: Error.
	
	self should: [a removeChildAt: 0] raise: Error.
	self should: [a removeChildAt: 2] raise: Error.
	self shouldnt: [a removeChildAt: 1] raise: Error.
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 14:29:06.552'!
test05BinaryTree
	| a b c |
	a := I2SBinaryTreeNode newWithValue: 5.
	self assert: 1 equals: a maxValues.
	self assert: 2 equals: a maxChildren.
	self assert: 5 equals: a value.
	
	b := I2SBinaryTreeNode newWithValue: 3.
	c := I2SBinaryTreeNode newWithValue: 7.
	
	a leftChild: b.
	self assert: b equals: a leftChild.
	a leftChild: c.
	self assert: c equals: a leftChild.
	a rightChild: b.
	self assert: b equals: a rightChild.
	
	c value: 8.
	self assert: 8 equals: c value.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:16:59.938'!
test06BinarySearchTree
	| root |
	root := I2SBinarySearchTreeNode newWithValue: 5.
	root addValue: 3.
	root addValue: 7.
	root addValue: 14.
	root addValue: 4.
	
	self assert: 5 equals: root value.
	self assert: 3 equals: root leftChild value.
	self assert: 7 equals: root rightChild value.
	self assert: 14 equals: root rightChild rightChild value.
	self assert: (root leftChild leftChild) isNil.
	self assert: (root rightChild leftChild) isNil.
	self assert: (root find: 5).
	self assert: (root find: 7).
	self assert: (root find: 3).
	self assert: (root find: 14).
	self assert: (root find: 4).
	self assert: (root find: 20) not.
	self assert: (root find: 10) not.
	self assert: (root find: 0) not.! !

TestCase subclass: #I2SVisualizationTests
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:50:14.849'!
setUp
	
	super setUp.
	visualization := I2SVisualization new. 
	! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:47:46.047'!
tearDown
	
	visualization delete.
	super tearDown! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:28:54.794'!
test01SimpleTree
	| a b c |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.

	a addChild: b at: 1.
	a addChild: c at: 2.

	(visualization setRootNode: a)	openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:48:29.315'!
test02UpdateTree

	| root child |
	root := I2STreeNode new.
	root setValue: Color red at: 1.
	
	(visualization setRootNode: root) openInWorld.
	
	child := I2STreeNode new.
	child setValue: Color blue at: 1.
	
	root addChild: child at: 1.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:49:19.894'!
test03RemoveChild

	| root child |
	root := I2STreeNode new.
	root setValue: Color red at: 1.
			
	child := I2STreeNode new.
	child setValue: Color blue at: 1.
	
	root addChild: child at: 1.
	
	(visualization setRootNode: root) openInWorld.
		
	root removeChildAt: 1.
! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 11:53:51.14'!
test04MoarDepth
	| a b c d |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.
	
	d := I2STreeNode new.
	d setValue: Color yellow at: 1.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	
	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:01:35.204'!
test05ComplexTree

| a b c d e f g |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.
	
	d := I2STreeNode new.
	d setValue: Color yellow at: 1.

	e := I2STreeNode new.
	e setValue: Color yellow at: 1.
	
	f := I2STreeNode new.
	f setValue: Color yellow at: 1.

	g := I2STreeNode new.
	g setValue: Color yellow at: 1.	

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	b addChild: e at: 2.
	c addChild: f at: 1.

	(visualization setRootNode: a) openInWorld.! !
